package com.caimei.modules.club.entity;

import org.hibernate.validator.constraints.Length;

import java.beans.Transient;
import java.io.Serializable;

/**
 * 用户Entity
 *
 * @author ZCP
 * @version 2017-10-10
 */
public class CmUser implements Serializable {

    private static final long serialVersionUID = 1L;
    private Integer userID;        // userID
    private Integer userOrganizeID;//用户组织ID
    private String mobile;        // 手机号码
    private Integer userPermission;        // 用户权限
    private String email;        // 邮箱
    private String userName;        // 用户名
    private String image;        // image
    private String password;        // 密码
    private String userLevelID;        // 用户会员等级，见表c_userlevel或枚举UserLevel
    private String name;        // 组织名称
    private String nick;        // 昵称
    private String sex;        // 性别
    private String registerUserTypeID;        // 用户类型，见表c_usertype或枚举UserType
    private String manufacturerFlag;        // 已废弃 是否是供应商，1是 空或0否
    private String manufacturerStatus;        // 供应商状态，见表c_shopstatus或枚举ShopStatus
    private String shopID;        // 供应商Id
    private String serviceProviderFlag;        // 已废弃  是否创客，1是 空或0否
    private String clubFlag;        //已废弃  是否会所，1是 空或0否
    private String masterFlag;        //已废弃  masterFlag
    private String normalFlag;        //已废弃  normalFlag
    private String auditStatus;        // auditStatus
    private String auditTime;        // auditTime
    private String auditNote;        // auditNote
    private String registerTime;        // 注册时间
    private String registerIP;        // 注册ip
    private String loginTime;        // 登录时间
    private String loginFailTime;        // 登录失败次数
    private String loginIP;        // 登录ip
    private String validFlag;        // 用户状态，1正常，0冻结
    private String emailCheckFlag;        // emailCheckFlag
    private String mobileCheckFlag;        // mobileCheckFlag
    private String clubStatus;        // 会所状态，见表c_clubstatus或枚举ClubStatus
    private String clubID;        // 会所Id
    private String agreeFlag;        // agreeFlag
    private String activationCode;        // activationCode
    private String activationDate;        // activationDate
    private String serviceProviderStatus;        // 创客状态
    private String serviceProviderID;        // 创客Id
    private String masterStatus;        // masterStatus
    private String masterID;        // masterID
    private Double userMoney;        // 账户余额
    private Double ableUserMoney;        //账户可用余额
    private String point;        // point
    private String shopERPFlag;        // shopERPFlag
    private String fromUserID;        // 邀请人Id
    private String fromUserName;        // 邀请人名称
    private String logoffTime;        // logoffTime
    private String appKey;        // appKey
    private String appSecret;        // appSecret
    private String sampleFlag;        // sampleFlag
    private String scanFlag;        // 扫描标志(4 CRM拉上来的会所)
    private String sysroleid;        // sysroleid
    private String gender;        // gender
    private String age;        // 年龄
    private String salerbuyer;        // salerbuyer
    private String position;        // position
    private String skill;        // skill
    private String workage;        // workage
    private String wechat;        // 微信号
    private String qq;        // QQ号
    private String smsFlag;        // 短信是否发送成功
    private String userBeans;        // 采美豆数量
    private String privateShopFlag;        // 平台商标志位  0非平台商 1平台商
    private String privateClubFlag;        // 平台会所标志位  0非平台会所 1平台会所
    private String isMeiDaoAuthorized;        // isMeiDaoAuthorized
    private String guideFlag;        // 引导层弹出  0需要弹出  1不需要弹出
    private String nickName;        // 微信昵称
    private String startTime;     //注册时间开始 查询条件
    private String endTime;        //注册时间结束  查询条件


    /**
     * 用户模块重构
     */
    private String account;//账号名： 企业账号登录使用
    private Integer userIdentity;//用户身份
    private String realName;//真实姓名
    private Integer companyUserID;//企业用户id
    private String openID;//微信openID
    private String bindMobile;//企业绑定手机号
    private String tipStatus;//弹窗提示状态
    private String identityDisplay; //前台身份展示
    private String linkMan;//联系人

    //会所用户信息
    private String town; // 区
    private String city; // 市
    private String province; //省
    private String address;        // 详细地址

    public Integer getUserID() {
        return userID;
    }

    public void setUserID(Integer userID) {
        this.userID = userID;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public Integer getUserPermission() {
        return userPermission;
    }

    public void setUserPermission(Integer userPermission) {
        this.userPermission = userPermission;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getUserLevelID() {
        return userLevelID;
    }

    public void setUserLevelID(String userLevelID) {
        this.userLevelID = userLevelID;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getNick() {
        return nick;
    }

    public void setNick(String nick) {
        this.nick = nick;
    }

    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }

    public String getRegisterUserTypeID() {
        return registerUserTypeID;
    }

    public void setRegisterUserTypeID(String registerUserTypeID) {
        this.registerUserTypeID = registerUserTypeID;
    }

    @Length(min = 0, max = 1, message = "是否是供应商，1是 空或0否长度必须介于 0 和 1 之间")
    public String getManufacturerFlag() {
        return manufacturerFlag;
    }

    public void setManufacturerFlag(String manufacturerFlag) {
        this.manufacturerFlag = manufacturerFlag;
    }

    @Length(min = 0, max = 11, message = "供应商状态，见表c_shopstatus或枚举ShopStatus长度必须介于 0 和 11 之间")
    public String getManufacturerStatus() {
        return manufacturerStatus;
    }

    public void setManufacturerStatus(String manufacturerStatus) {
        this.manufacturerStatus = manufacturerStatus;
    }

    @Length(min = 0, max = 11, message = "供应商Id长度必须介于 0 和 11 之间")
    public String getShopID() {
        return shopID;
    }

    public void setShopID(String shopID) {
        this.shopID = shopID;
    }

    @Length(min = 0, max = 1, message = "是否创客，1是 空或0否长度必须介于 0 和 1 之间")
    public String getServiceProviderFlag() {
        return serviceProviderFlag;
    }

    public void setServiceProviderFlag(String serviceProviderFlag) {
        this.serviceProviderFlag = serviceProviderFlag;
    }

    @Length(min = 0, max = 1, message = "是否会所，1是 空或0否长度必须介于 0 和 1 之间")
    public String getClubFlag() {
        return clubFlag;
    }

    public void setClubFlag(String clubFlag) {
        this.clubFlag = clubFlag;
    }

    @Length(min = 0, max = 1, message = "masterFlag长度必须介于 0 和 1 之间")
    public String getMasterFlag() {
        return masterFlag;
    }

    public void setMasterFlag(String masterFlag) {
        this.masterFlag = masterFlag;
    }

    @Length(min = 0, max = 1, message = "normalFlag长度必须介于 0 和 1 之间")
    public String getNormalFlag() {
        return normalFlag;
    }

    public void setNormalFlag(String normalFlag) {
        this.normalFlag = normalFlag;
    }

    @Length(min = 0, max = 1, message = "auditStatus长度必须介于 0 和 1 之间")
    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    @Length(min = 0, max = 19, message = "auditTime长度必须介于 0 和 19 之间")
    public String getAuditTime() {
        return auditTime;
    }

    public void setAuditTime(String auditTime) {
        this.auditTime = auditTime;
    }

    @Length(min = 0, max = 100, message = "auditNote长度必须介于 0 和 100 之间")
    public String getAuditNote() {
        return auditNote;
    }

    public void setAuditNote(String auditNote) {
        this.auditNote = auditNote;
    }

    public String getRegisterTime() {
        return registerTime;
    }

    public void setRegisterTime(String registerTime) {
        this.registerTime = registerTime;
    }

    public String getRegisterIP() {
        return registerIP;
    }

    public void setRegisterIP(String registerIP) {
        this.registerIP = registerIP;
    }

    public String getLoginTime() {
        return loginTime;
    }

    public void setLoginTime(String loginTime) {
        this.loginTime = loginTime;
    }

    public String getLoginFailTime() {
        return loginFailTime;
    }

    public void setLoginFailTime(String loginFailTime) {
        this.loginFailTime = loginFailTime;
    }

    public String getLoginIP() {
        return loginIP;
    }

    public void setLoginIP(String loginIP) {
        this.loginIP = loginIP;
    }

    public String getValidFlag() {
        return validFlag;
    }

    public void setValidFlag(String validFlag) {
        this.validFlag = validFlag;
    }

    public String getEmailCheckFlag() {
        return emailCheckFlag;
    }

    public void setEmailCheckFlag(String emailCheckFlag) {
        this.emailCheckFlag = emailCheckFlag;
    }

    public String getMobileCheckFlag() {
        return mobileCheckFlag;
    }

    public void setMobileCheckFlag(String mobileCheckFlag) {
        this.mobileCheckFlag = mobileCheckFlag;
    }

    public String getClubStatus() {
        return clubStatus;
    }

    public void setClubStatus(String clubStatus) {
        this.clubStatus = clubStatus;
    }

    public String getClubID() {
        return clubID;
    }

    public void setClubID(String clubID) {
        this.clubID = clubID;
    }

    public String getAgreeFlag() {
        return agreeFlag;
    }

    public void setAgreeFlag(String agreeFlag) {
        this.agreeFlag = agreeFlag;
    }

    public String getActivationCode() {
        return activationCode;
    }

    public void setActivationCode(String activationCode) {
        this.activationCode = activationCode;
    }

    public String getActivationDate() {
        return activationDate;
    }

    public void setActivationDate(String activationDate) {
        this.activationDate = activationDate;
    }

    @Length(min = 0, max = 11, message = "创客状态长度必须介于 0 和 11 之间")
    public String getServiceProviderStatus() {
        return serviceProviderStatus;
    }

    public void setServiceProviderStatus(String serviceProviderStatus) {
        this.serviceProviderStatus = serviceProviderStatus;
    }

    @Length(min = 0, max = 11, message = "创客Id长度必须介于 0 和 11 之间")
    public String getServiceProviderID() {
        return serviceProviderID;
    }

    public void setServiceProviderID(String serviceProviderID) {
        this.serviceProviderID = serviceProviderID;
    }

    @Length(min = 0, max = 11, message = "masterStatus长度必须介于 0 和 11 之间")
    public String getMasterStatus() {
        return masterStatus;
    }

    public void setMasterStatus(String masterStatus) {
        this.masterStatus = masterStatus;
    }

    @Length(min = 0, max = 11, message = "masterID长度必须介于 0 和 11 之间")
    public String getMasterID() {
        return masterID;
    }

    public void setMasterID(String masterID) {
        this.masterID = masterID;
    }

    public Double getUserMoney() {
        return userMoney;
    }

    public void setUserMoney(Double userMoney) {
        this.userMoney = userMoney;
    }

    public Double getAbleUserMoney() {
        return ableUserMoney;
    }

    public void setAbleUserMoney(Double ableUserMoney) {
        this.ableUserMoney = ableUserMoney;
    }

    @Length(min = 0, max = 11, message = "point长度必须介于 0 和 11 之间")
    public String getPoint() {
        return point;
    }

    public void setPoint(String point) {
        this.point = point;
    }

    @Length(min = 0, max = 1, message = "shopERPFlag长度必须介于 0 和 1 之间")
    public String getShopERPFlag() {
        return shopERPFlag;
    }

    public void setShopERPFlag(String shopERPFlag) {
        this.shopERPFlag = shopERPFlag;
    }

    @Length(min = 0, max = 11, message = "邀请人Id长度必须介于 0 和 11 之间")
    public String getFromUserID() {
        return fromUserID;
    }

    public void setFromUserID(String fromUserID) {
        this.fromUserID = fromUserID;
    }

    public String getFromUserName() {
        return fromUserName;
    }

    public void setFromUserName(String fromUserName) {
        this.fromUserName = fromUserName;
    }

    public String getLogoffTime() {
        return logoffTime;
    }

    public void setLogoffTime(String logoffTime) {
        this.logoffTime = logoffTime;
    }

    @Length(min = 0, max = 20, message = "appKey长度必须介于 0 和 20 之间")
    public String getAppKey() {
        return appKey;
    }

    public void setAppKey(String appKey) {
        this.appKey = appKey;
    }

    @Length(min = 0, max = 25, message = "appSecret长度必须介于 0 和 25 之间")
    public String getAppSecret() {
        return appSecret;
    }

    public void setAppSecret(String appSecret) {
        this.appSecret = appSecret;
    }

    @Length(min = 0, max = 1, message = "sampleFlag长度必须介于 0 和 1 之间")
    public String getSampleFlag() {
        return sampleFlag;
    }

    public void setSampleFlag(String sampleFlag) {
        this.sampleFlag = sampleFlag;
    }

    @Length(min = 0, max = 11, message = "扫描标志(4 CRM拉上来的会所)长度必须介于 0 和 11 之间")
    public String getScanFlag() {
        return scanFlag;
    }

    public void setScanFlag(String scanFlag) {
        this.scanFlag = scanFlag;
    }

    @Length(min = 0, max = 11, message = "sysroleid长度必须介于 0 和 11 之间")
    public String getSysroleid() {
        return sysroleid;
    }

    public void setSysroleid(String sysroleid) {
        this.sysroleid = sysroleid;
    }

    @Length(min = 0, max = 2, message = "gender长度必须介于 0 和 2 之间")
    public String getGender() {
        return gender;
    }

    public void setGender(String gender) {
        this.gender = gender;
    }

    @Length(min = 0, max = 11, message = "年龄长度必须介于 0 和 11 之间")
    public String getAge() {
        return age;
    }

    public void setAge(String age) {
        this.age = age;
    }

    @Length(min = 0, max = 11, message = "salerbuyer长度必须介于 0 和 11 之间")
    public String getSalerbuyer() {
        return salerbuyer;
    }

    public void setSalerbuyer(String salerbuyer) {
        this.salerbuyer = salerbuyer;
    }

    @Length(min = 0, max = 128, message = "position长度必须介于 0 和 128 之间")
    public String getPosition() {
        return position;
    }

    public void setPosition(String position) {
        this.position = position;
    }

    @Length(min = 0, max = 128, message = "skill长度必须介于 0 和 128 之间")
    public String getSkill() {
        return skill;
    }

    public void setSkill(String skill) {
        this.skill = skill;
    }

    public String getWorkage() {
        return workage;
    }

    public void setWorkage(String workage) {
        this.workage = workage;
    }

    @Length(min = 0, max = 64, message = "微信号长度必须介于 0 和 64 之间")
    public String getWechat() {
        return wechat;
    }

    public void setWechat(String wechat) {
        this.wechat = wechat;
    }

    @Length(min = 0, max = 32, message = "QQ号长度必须介于 0 和 32 之间")
    public String getQq() {
        return qq;
    }

    public void setQq(String qq) {
        this.qq = qq;
    }

    @Length(min = 0, max = 1, message = "短信是否发送成功长度必须介于 0 和 1 之间")
    public String getSmsFlag() {
        return smsFlag;
    }

    public void setSmsFlag(String smsFlag) {
        this.smsFlag = smsFlag;
    }

    @Length(min = 0, max = 11, message = "采美豆数量长度必须介于 0 和 11 之间")
    public String getUserBeans() {
        return userBeans;
    }

    public void setUserBeans(String userBeans) {
        this.userBeans = userBeans;
    }

    @Length(min = 0, max = 11, message = "平台商标志位  0非平台商 1平台商长度必须介于 0 和 11 之间")
    public String getPrivateShopFlag() {
        return privateShopFlag;
    }

    public void setPrivateShopFlag(String privateShopFlag) {
        this.privateShopFlag = privateShopFlag;
    }

    @Length(min = 0, max = 11, message = "平台会所标志位  0非平台会所 1平台会所长度必须介于 0 和 11 之间")
    public String getPrivateClubFlag() {
        return privateClubFlag;
    }

    public void setPrivateClubFlag(String privateClubFlag) {
        this.privateClubFlag = privateClubFlag;
    }

    @Length(min = 0, max = 11, message = "isMeiDaoAuthorized长度必须介于 0 和 11 之间")
    public String getIsMeiDaoAuthorized() {
        return isMeiDaoAuthorized;
    }

    public void setIsMeiDaoAuthorized(String isMeiDaoAuthorized) {
        this.isMeiDaoAuthorized = isMeiDaoAuthorized;
    }

    @Length(min = 0, max = 1, message = "引导层弹出  0需要弹出  1不需要弹出长度必须介于 0 和 1 之间")
    public String getGuideFlag() {
        return guideFlag;
    }

    public void setGuideFlag(String guideFlag) {
        this.guideFlag = guideFlag;
    }

    public String getNickName() {
        return nickName;
    }

    public void setNickName(String nickName) {
        this.nickName = nickName;
    }

    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public Integer getUserIdentity() {
        return userIdentity;
    }

    public void setUserIdentity(Integer userIdentity) {
        this.userIdentity = userIdentity;
    }

    public String getRealName() {
        return realName;
    }

    public void setRealName(String realName) {
        this.realName = realName;
    }

    public Integer getCompanyUserID() {
        return companyUserID;
    }

    public void setCompanyUserID(Integer companyUserID) {
        this.companyUserID = companyUserID;
    }

    public String getOpenID() {
        return openID;
    }

    public void setOpenID(String openID) {
        this.openID = openID;
    }

    public String getBindMobile() {
        return bindMobile;
    }

    public void setBindMobile(String bindMobile) {
        this.bindMobile = bindMobile;
    }

    public String getTipStatus() {
        return tipStatus;
    }

    public void setTipStatus(String tipStatus) {
        this.tipStatus = tipStatus;
    }

    @Transient
    public String getIdentityDisplay() {
        return identityDisplay;
    }

    public void setIdentityDisplay(String identityDisplay) {
        this.identityDisplay = identityDisplay;
    }

    @Transient
    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    @Transient
    public String getEndTime() {
        return endTime;
    }

    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }

    public Integer getUserOrganizeID() {
        return userOrganizeID;
    }

    public void setUserOrganizeID(Integer userOrganizeID) {
        this.userOrganizeID = userOrganizeID;
    }

    public String getLinkMan() {
        return linkMan;
    }

    public void setLinkMan(String linkMan) {
        this.linkMan = linkMan;
    }

    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }
}