package com.caimei.modules.order.controller;


import com.caimei.modules.order.entity.CmOrderRemark;
import com.caimei.modules.order.service.CmOrderRemarkService;
import com.caimei.modules.shiro.entity.CmMallAdminUser;
import com.caimei.modules.shiro.service.ShiroService;
import com.caimei.utils.JsonModel;
import com.caimei.utils.TokenEncryptUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;

/**
 * 订单备注Controller
 */
@Controller
@RequestMapping(value = "/order/cmOrderRemark")
public class CmOrderRemarkController {

    @Autowired
    private CmOrderRemarkService cmOrderRemarkService;
    @Autowired
    private ShiroService shiroService;

    @ModelAttribute
    public CmOrderRemark get(@RequestParam(required = false) String id) {
        CmOrderRemark entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = cmOrderRemarkService.get(id);
        }
        if (entity == null) {
            entity = new CmOrderRemark();
        }
        return entity;
    }

    //订单备注
    @ResponseBody
    @RequestMapping(value = "remarksView")
    public JsonModel remarksView(Integer orderID) {
        //通过商品ID获取对应备注信息
        CmOrderRemark remark = new CmOrderRemark();
        remark.setOrderID(orderID);
        List<CmOrderRemark> remarksList = cmOrderRemarkService.findList(remark);
        return JsonModel.newInstance().success(remarksList);
    }


    /**
     * 保存备注
     *
     * @param remarks
     * @param orderID
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "addRemarks", method = RequestMethod.POST)
    public JsonModel addRemarks(@RequestBody String remarks, @RequestBody Integer orderID, HttpServletRequest httpRequest) {
        JsonModel jsonModel = JsonModel.newInstance();
        String token = httpRequest.getHeader("token");
        String decoded = TokenEncryptUtils.decoded(token);
        String[] tokens = decoded.split("#,#");
        //用户信息
        CmMallAdminUser user = shiroService.findByUserId(Integer.valueOf(tokens[1]));
        try {
            //保存备注信息
            CmOrderRemark remark = new CmOrderRemark();
            remark.setOrderID(orderID);
            remark.setRemarks(remarks);
            remark.setCreateBy(user.getId());
            remark.setCreateDate(new Date());
            cmOrderRemarkService.save(remark);
            return jsonModel.success();
        } catch (Exception e) {
            return jsonModel.error("修改失败");
        }
    }
}