package com.caimei.modules.order.controller;

import com.caimei.modules.club.entity.Page;
import com.caimei.modules.order.entity.BpClause;
import com.caimei.modules.order.entity.CmReturnedPurchase;
import com.caimei.modules.order.entity.NewOrder;
import com.caimei.modules.order.service.BpClauseService;
import com.caimei.modules.order.service.CmReturnedPurchaseService;
import com.caimei.modules.order.service.NewOrderService;
import com.caimei.utils.JsonModel;
import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 退货退款Controller
 */
@Controller
@RequestMapping(value = "/order/cmReturnedPurchase")
public class CmReturnedPurchaseController {
    @Autowired
    private CmReturnedPurchaseService cmReturnedPurchaseService;
    @Autowired
    private NewOrderService newOrderService;
    @Autowired
    private BpClauseService bpClauseService;


    /**
     * 用户退款列表
     *
     * @param cmReturnedPurchase
     * @param page
     * @return
     */
    @ResponseBody
    @RequestMapping(value = "list")
    public JsonModel list(CmReturnedPurchase cmReturnedPurchase, Page page) {
        PageHelper.startPage(page.getIndex(), page.getPageSize());
        List<CmReturnedPurchase> returnedPurchaseList = cmReturnedPurchaseService.findList(cmReturnedPurchase);
        Page<CmReturnedPurchase> purchasePage = new Page<>(returnedPurchaseList);
        return JsonModel.newInstance().success(purchasePage);
    }

    /**
     * 退款详情
     */
    @ResponseBody
    @RequestMapping(value = "toRecturnRecord")
    public JsonModel toRecturnRecord(CmReturnedPurchase cmReturnedPurchase) {
        Map<String, Object> map = new HashMap();
        try {
            NewOrder newOrder = newOrderService.get(cmReturnedPurchase.getOrderID().toString());
            List<CmReturnedPurchase> dataList = cmReturnedPurchaseService.getReturnedPurchaseList(cmReturnedPurchase);
            BpClause bpClause = new BpClause();
            bpClause.setEnabledStatus("1");
            List<BpClause> bpClauses = bpClauseService.findList(bpClause);
            Double returnedPurchaseFee = 0D;    //退款(退货)总金额
            Double refundFee = 0D;  //退款总额(给买家)
            for (CmReturnedPurchase bean : dataList) {
                if (!bean.getStatus().equals("3")) {
                    returnedPurchaseFee += bean.getReturnedPurchaseFee();
                    refundFee += bean.getRefundFee();
                }
            }
            map.put("bpClauses", bpClauses);
            map.put("cmReturnedPurchaseList", dataList);
            map.put("order", newOrder);
            map.put("returnedPurchaseFee", returnedPurchaseFee);
            map.put("refundFee", refundFee);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JsonModel.newInstance().success(map);
    }
}