package com.caimei.modules.order.entity;

import org.hibernate.validator.constraints.Length;

import java.beans.Transient;
import java.io.Serializable;

/**
 * 收款项和订单关系Entity
 *
 * @author lwt
 * @version 2019-06-20
 */
public class CmReceiptOrderRelation implements Serializable {

    private static final long serialVersionUID = 1L;
    private Integer id;
    private String relationType;        // 关系类型：1返佣订单（返佣款）、2非返佣订单（订单款或者非订单款）
    private String receiptID;        // 识别款项Id（对应cm_discern_receipt表）
    private String associateAmount;        // 关联金额：1普通收款(线下):收款具体对该应母订单的收金额、2线上支付:付款金额就等于该金额、3返佣收款：默认为0
    private String orderID;        // 订单Id（relationType值为1是为子订单ID,为2时为主订单ID）

    private String payType;    //收款类型
    private String receiptDate;    //收款时间
    private String confirmType;        //确认订单类型

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Length(min = 0, max = 1, message = "关系类型：1返佣订单（返佣款）、2非返佣订单（订单款或者非订单款）长度必须介于 0 和 1 之间")
    public String getRelationType() {
        return relationType;
    }

    public void setRelationType(String relationType) {
        this.relationType = relationType;
    }

    @Length(min = 0, max = 11, message = "识别款项Id（对应cm_discern_receipt表）长度必须介于 0 和 11 之间")
    public String getReceiptID() {
        return receiptID;
    }

    public void setReceiptID(String receiptID) {
        this.receiptID = receiptID;
    }

    public String getAssociateAmount() {
        return associateAmount;
    }

    public void setAssociateAmount(String associateAmount) {
        this.associateAmount = associateAmount;
    }

    @Length(min = 0, max = 11, message = "订单Id（relationType值为1是为子订单ID,为2时为主订单ID）长度必须介于 0 和 11 之间")
    public String getOrderID() {
        return orderID;
    }

    public void setOrderID(String orderID) {
        this.orderID = orderID;
    }

    @Transient
    public String getPayType() {
        return payType;
    }

    public void setPayType(String payType) {
        this.payType = payType;
    }

    @Transient
    public String getReceiptDate() {
        return receiptDate;
    }

    public void setReceiptDate(String receiptDate) {
        this.receiptDate = receiptDate;
    }

    @Transient
    public String getConfirmType() {
        return confirmType;
    }

    public void setConfirmType(String confirmType) {
        this.confirmType = confirmType;
    }
}