package com.caimei.modules.order.entity;

import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 退货退款Entity
 *
 * @author ye.qin
 * @version 2019-05-24
 */
public class CmReturnedPurchase implements Serializable {

    private static final long serialVersionUID = 1L;
    private Integer id;
    private String returnedNo;        // 退款退货编号
    private Integer orderID;        // 主订单ID
    private Integer organizeID;    //组织id
    private String orderNo;         //主订单号
    private String userName;        //买家名
    //	private Integer shopOrderID;		// 子订单Id
    private Integer userID;        // 用户ID（买家）
    private String status;        // 状态：1待审核、2审核通过、3审核不通过
    private String returnedWay;        // 退款方式 1有支付有退款(退款方式可多选具体参考以上金额)、4未支付无退款（未支付发起退款）
    private String payType;//付款方式 付款方式 1建设银行7297, 2中信银行0897, 3中信银行7172, 4广发银行0115, 5广发银行5461
    private String returnedBankInfo;        // 退款银行信息（银行名称、户名、开户行、银行账号）【V6.1.1版本已废弃拆分显示】
    private String operatingOrderStatus;    //发起该操作时订单状态快照：0待确认,11待收待发,12待收部发,13待收全发,21部收待发,22部收部发,23部收全发,31已收待发,32已收部发,33已收全发,4交易完成,5订单完成,6已关闭,7交易全退
    private Double returnedPurchaseFee;        // 退款(退货)总金额
    private Double refundFee;        // 退款总额(给买家)
    private String image1;        // 凭证图片1
    private String image2;        // 凭证图片2
    private String image3;        // 凭证图片3
    private String image4;        // 凭证图片4
    private String image5;        // 凭证图片5

    private String reviewImage1;        // 凭证图片1
    private String reviewImage2;        // 凭证图片2
    private String reviewImage3;        // 凭证图片3
    private String reviewImage4;        // 凭证图片4
    private String reviewImage5;        // 凭证图片5

    private String reviewRemarks;   //审核备注
    private String returnTime;        // 申请退款时间
    private String confirmReturnTime;        // 确认退款时间(审核退款时间)

    @DateTimeFormat
    private Date beginReturnTime;
    @DateTimeFormat
    private Date endReturnTime;

    private Date beginConfirmReturnTime;
    private Date endConfirmReturnTime;

    //private List<List<CmReturnedPurchaseProduct>> cmReturnedPurchaseProductList;    //退款退货商品列表(用于前端接收)
    private List<ShopOrderReturned> shopOrderReturnedList;    //退款退货商品列表
    //private List<CmReturnedPurchaseProduct> productList;    //退款退货商品列表

    private String bankAccountName;//银行账户名
    private String bankAccountNo;//开户银行账户
    private String openBank;//开户银行
    private String bankAccountType;//账户类型：1公账，2私账
    private Double refundBalanceFee;//退账户余额
    private Double refundOnlineFee;//退线上退回
    private Double refundOfflineFee;//退线下转账
    private Integer applicationUserID;//申请人ID
    private Integer reviewUserID;//审核人ID
    //	private String reviewTime;		// 申请审核时间
    private String applicationUserName;//申请人
    private String reviewUserName;//审核人

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getReturnedNo() {
        return returnedNo;
    }

    public void setReturnedNo(String returnedNo) {
        this.returnedNo = returnedNo;
    }

    public Integer getOrderID() {
        return orderID;
    }

    public void setOrderID(Integer orderID) {
        this.orderID = orderID;
    }

    public Integer getOrganizeID() {
        return organizeID;
    }

    public void setOrganizeID(Integer organizeID) {
        this.organizeID = organizeID;
    }

    public String getOrderNo() {
        return orderNo;
    }

    public void setOrderNo(String orderNo) {
        this.orderNo = orderNo;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public Integer getUserID() {
        return userID;
    }

    public void setUserID(Integer userID) {
        this.userID = userID;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getReturnedWay() {
        return returnedWay;
    }

    public void setReturnedWay(String returnedWay) {
        this.returnedWay = returnedWay;
    }

    public String getPayType() {
        return payType;
    }

    public void setPayType(String payType) {
        this.payType = payType;
    }

    public String getReturnedBankInfo() {
        return returnedBankInfo;
    }

    public void setReturnedBankInfo(String returnedBankInfo) {
        this.returnedBankInfo = returnedBankInfo;
    }

    public String getOperatingOrderStatus() {
        return operatingOrderStatus;
    }

    public void setOperatingOrderStatus(String operatingOrderStatus) {
        this.operatingOrderStatus = operatingOrderStatus;
    }

    public Double getReturnedPurchaseFee() {
        return returnedPurchaseFee;
    }

    public void setReturnedPurchaseFee(Double returnedPurchaseFee) {
        this.returnedPurchaseFee = returnedPurchaseFee;
    }

    public Double getRefundFee() {
        return refundFee;
    }

    public void setRefundFee(Double refundFee) {
        this.refundFee = refundFee;
    }

    public String getImage1() {
        return image1;
    }

    public void setImage1(String image1) {
        this.image1 = image1;
    }

    public String getImage2() {
        return image2;
    }

    public void setImage2(String image2) {
        this.image2 = image2;
    }

    public String getImage3() {
        return image3;
    }

    public void setImage3(String image3) {
        this.image3 = image3;
    }

    public String getImage4() {
        return image4;
    }

    public void setImage4(String image4) {
        this.image4 = image4;
    }

    public String getImage5() {
        return image5;
    }

    public void setImage5(String image5) {
        this.image5 = image5;
    }

    public String getReviewImage1() {
        return reviewImage1;
    }

    public void setReviewImage1(String reviewImage1) {
        this.reviewImage1 = reviewImage1;
    }

    public String getReviewImage2() {
        return reviewImage2;
    }

    public void setReviewImage2(String reviewImage2) {
        this.reviewImage2 = reviewImage2;
    }

    public String getReviewImage3() {
        return reviewImage3;
    }

    public void setReviewImage3(String reviewImage3) {
        this.reviewImage3 = reviewImage3;
    }

    public String getReviewImage4() {
        return reviewImage4;
    }

    public void setReviewImage4(String reviewImage4) {
        this.reviewImage4 = reviewImage4;
    }

    public String getReviewImage5() {
        return reviewImage5;
    }

    public void setReviewImage5(String reviewImage5) {
        this.reviewImage5 = reviewImage5;
    }

    public String getReviewRemarks() {
        return reviewRemarks;
    }

    public void setReviewRemarks(String reviewRemarks) {
        this.reviewRemarks = reviewRemarks;
    }

    public String getReturnTime() {
        return returnTime;
    }

    public void setReturnTime(String returnTime) {
        this.returnTime = returnTime;
    }

    public String getConfirmReturnTime() {
        return confirmReturnTime;
    }

    public void setConfirmReturnTime(String confirmReturnTime) {
        this.confirmReturnTime = confirmReturnTime;
    }

    public Date getBeginReturnTime() {
        return beginReturnTime;
    }

    public void setBeginReturnTime(Date beginReturnTime) {
        this.beginReturnTime = beginReturnTime;
    }

    public Date getEndReturnTime() {
        return endReturnTime;
    }

    public void setEndReturnTime(Date endReturnTime) {
        this.endReturnTime = endReturnTime;
    }

    public Date getBeginConfirmReturnTime() {
        return beginConfirmReturnTime;
    }

    public void setBeginConfirmReturnTime(Date beginConfirmReturnTime) {
        this.beginConfirmReturnTime = beginConfirmReturnTime;
    }

    public Date getEndConfirmReturnTime() {
        return endConfirmReturnTime;
    }

    public void setEndConfirmReturnTime(Date endConfirmReturnTime) {
        this.endConfirmReturnTime = endConfirmReturnTime;
    }

    public List<ShopOrderReturned> getShopOrderReturnedList() {
        return shopOrderReturnedList;
    }

    public void setShopOrderReturnedList(List<ShopOrderReturned> shopOrderReturnedList) {
        this.shopOrderReturnedList = shopOrderReturnedList;
    }

    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    public String getBankAccountNo() {
        return bankAccountNo;
    }

    public void setBankAccountNo(String bankAccountNo) {
        this.bankAccountNo = bankAccountNo;
    }

    public String getOpenBank() {
        return openBank;
    }

    public void setOpenBank(String openBank) {
        this.openBank = openBank;
    }

    public String getBankAccountType() {
        return bankAccountType;
    }

    public void setBankAccountType(String bankAccountType) {
        this.bankAccountType = bankAccountType;
    }

    public Double getRefundBalanceFee() {
        return refundBalanceFee;
    }

    public void setRefundBalanceFee(Double refundBalanceFee) {
        this.refundBalanceFee = refundBalanceFee;
    }

    public Double getRefundOnlineFee() {
        return refundOnlineFee;
    }

    public void setRefundOnlineFee(Double refundOnlineFee) {
        this.refundOnlineFee = refundOnlineFee;
    }

    public Double getRefundOfflineFee() {
        return refundOfflineFee;
    }

    public void setRefundOfflineFee(Double refundOfflineFee) {
        this.refundOfflineFee = refundOfflineFee;
    }

    public Integer getApplicationUserID() {
        return applicationUserID;
    }

    public void setApplicationUserID(Integer applicationUserID) {
        this.applicationUserID = applicationUserID;
    }

    public Integer getReviewUserID() {
        return reviewUserID;
    }

    public void setReviewUserID(Integer reviewUserID) {
        this.reviewUserID = reviewUserID;
    }

    public String getApplicationUserName() {
        return applicationUserName;
    }

    public void setApplicationUserName(String applicationUserName) {
        this.applicationUserName = applicationUserName;
    }

    public String getReviewUserName() {
        return reviewUserName;
    }

    public void setReviewUserName(String reviewUserName) {
        this.reviewUserName = reviewUserName;
    }
}