package com.caimei.modules.order.entity;

import org.hibernate.validator.constraints.Length;

import java.io.Serializable;

/**
 * 订单发票Entity
 * @author jiangjunwen
 * @version 2017-04-09
 */
public class OrderInvoice implements Serializable {
	
	private static final long serialVersionUID = 1L;
	private Integer id;
	private Long orderId;		// 订单ID
	private String invoiceTitle;		// 发票抬头 个人名称或企业名称
	private String invoiceType;		// 发票类型 普通发票
	private String invoiceContent;		// 发票内容 商品明细
	private String invoiceTitleType;		// 发票抬头类型 0个人  1 企业'
	private String corporationTaxNum;		// 企业税号

	private String type;//发票类型 0不开发票 1普通发票 2增值税发票
	private String registeredAddress;//注册地址
	private String registeredPhone;//注册电话
	private String bankAccountNo;//开户银行账户
	private String openBank;//开户银行

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getRegisteredAddress() {
		return registeredAddress;
	}

	public void setRegisteredAddress(String registeredAddress) {
		this.registeredAddress = registeredAddress;
	}

	public String getRegisteredPhone() {
		return registeredPhone;
	}

	public void setRegisteredPhone(String registeredPhone) {
		this.registeredPhone = registeredPhone;
	}

	public String getBankAccountNo() {
		return bankAccountNo;
	}

	public void setBankAccountNo(String bankAccountNo) {
		this.bankAccountNo = bankAccountNo;
	}

	public String getOpenBank() {
		return openBank;
	}

	public void setOpenBank(String openBank) {
		this.openBank = openBank;
	}

	public Long getOrderId() {
		return orderId;
	}

	public void setOrderId(Long orderId) {
		this.orderId = orderId;
	}
	
	@Length(min=0, max=100, message="发票抬头长度必须介于 0 和 100 之间")
	public String getInvoiceTitle() {
		return invoiceTitle;
	}

	public void setInvoiceTitle(String invoiceTitle) {
		this.invoiceTitle = invoiceTitle;
	}
	
	@Length(min=0, max=20, message="发票类型长度必须介于 0 和 20 之间")
	public String getInvoiceType() {
		return invoiceType;
	}

	public void setInvoiceType(String invoiceType) {
		this.invoiceType = invoiceType;
	}
	
	@Length(min=0, max=20, message="发票内容长度必须介于 0 和 20 之间")
	public String getInvoiceContent() {
		return invoiceContent;
	}

	public void setInvoiceContent(String invoiceContent) {
		this.invoiceContent = invoiceContent;
	}

	public String getInvoiceTitleType() {
		return invoiceTitleType;
	}

	public void setInvoiceTitleType(String invoiceTitleType) {
		this.invoiceTitleType = invoiceTitleType;
	}

	public String getCorporationTaxNum() {
		return corporationTaxNum;
	}

	public void setCorporationTaxNum(String corporationTaxNum) {
		this.corporationTaxNum = corporationTaxNum;
	}
}