package com.caimei.modules.order.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.caimei.modules.club.entity.CmProductSn;
import com.caimei.modules.order.dao.*;
import com.caimei.modules.order.entity.*;
import com.caimei.modules.order.service.NewShopOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class NewShopOrderServiceImpl implements NewShopOrderService {
    @Autowired
    private NewShopOrderDao newShopOrderDao;
    @Autowired
    private NewOrderProductDao newOrderProductDao;
    @Autowired
    private ProductDao productDao;
    @Autowired
    private CmProductSnDao cmProductSnDao;
    @Autowired
    private LogisticsBatchDao logisticsBatchDao;
    @Autowired
    private LogisticsRecordDao logisticsRecordDao;
    @Autowired
    private LogisticsInformationDao logisticsInformationDao;

    @Override
    public NewShopOrder findByShopOrderID(Integer shopOrderID) {
        NewShopOrder shopOrder = newShopOrderDao.findByShopOrderID(shopOrderID);
        List<NewOrderProduct> list = newOrderProductDao.findListByShopOrderID(shopOrder.getShopOrderID());
        List<NewOrderProduct> listSnProduct = new ArrayList<NewOrderProduct>();
        List<NewOrderProduct> listAll = new ArrayList<NewOrderProduct>();
        List<CmProductSn> listSn = new ArrayList<CmProductSn>();

        //通过产品ID查找一级分类，如果在（重光电或者轻光电下则是SN产品）
        if (null != list && list.size() > 0) {
            for (NewOrderProduct bean : list) {
                Integer productID = bean.getProductID();
                String bigTypeName = productDao.findProductBigTypeByProductID(productID);
                if (bigTypeName.equals(ProductType.Q1.getTypeName()) || bigTypeName.equals(ProductType.Q2.getTypeName())) {
                    listSn = cmProductSnDao.getListSignByOrderProduct(bean.getOrderProductID(), bean.getShopOrderID());
                    int num = bean.getNum() + bean.getPresentNum() - (listSn != null ? listSn.size() : 0);
                    for (int i = 0; i < num; i++) {
                        listSn.add(i, new CmProductSn());
                    }
                    bean.setCmProductSnList(listSn);
                    listSnProduct.add(bean);
                } else {
                    bean.setCmProductSnList(null);
                }
                listAll.add(bean);
            }
        }
        shopOrder.setSnOrderProducts(listSnProduct);
        shopOrder.setNewOrderProducts(listAll);
        return shopOrder;
    }

    @Override
    public List<LogisticsInfoVo> logisticsDetails(Integer orderID, String logisticsBatchID) {
        List<LogisticsInfoVo> result = new ArrayList<>();
        //查询这个子订单所有的发货批次记录
        List<LogisticsBatch> lbs = logisticsBatchDao.findBatch(orderID, logisticsBatchID);
        for (LogisticsBatch l : lbs) {
            LogisticsInfoVo liv = new LogisticsInfoVo();
            // 每一批的发货商品记录
            List<LogisticsRecord> lrs = logisticsRecordDao.findByLogisticsBatchID(l.getId());
            // 每一批的发货物流记录
            List<LogisticsInformation> lis = logisticsInformationDao.findByLogisticsBatchID(l.getId());
            for (LogisticsInformation information : lis) {
                List<LogisticsDetailVo> routers = JSONArray.parseArray(information.getInfo(), LogisticsDetailVo.class);
                information.setLogisticsDetailVos(routers);
            }
            liv.setLogisticsBatch(l);
            liv.setLogisticsInformationList(lis);
            liv.setLogisticsRecordList(lrs);
            result.add(liv);
        }
        return result;
    }
}
