package com.caimei.utils;

import com.alibaba.fastjson.JSONObject;

import java.io.Serializable;

public class JsonModel implements Serializable {

    private static final long serialVersionUID = 1L;

    private String code;  //状态码 1成功 -1失败
    private String msg;    //提示信息
    private Object data;        //返回结果


    public static JsonModel newInstance() {
        JsonModel jsonModel = new JsonModel();
        return jsonModel.success();
    }

    public JsonModel unLogin() {
        this.setMsg("请先登录");
        this.setCode("1002");
        return this;
    }

    public JsonModel success() {
        this.code = "1";
        this.msg = "操作成功";
        return this;
    }

    public JsonModel success(Object data) {
        this.code = "1";
        this.msg = "操作成功";
        this.data = data;
        return this;
    }

    public JsonModel success(String msg, Object data) {
        this.code = "1";
        this.msg = msg;
        this.data = data;
        return this;
    }

    public JsonModel success(String code, Object data, String msg) {
        this.code = code;
        this.msg = msg;
        this.data = data;
        return this;
    }


    public JsonModel error() {
        this.code = "-1";
        this.msg = "操作失败";
        return this;
    }

    public JsonModel error(String msg) {
        this.code = "-1";
        this.msg = msg;
        return this;
    }

    public JsonModel error(String code, String msg) {
        this.code = code;
        this.msg = msg;
        return this;
    }

    public JsonModel error(String code, Object data, String msg) {
        this.code = code;
        this.msg = msg;
        this.data = data;
        return this;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public Object getData() {
        return data;
    }

    public void setData(Object data) {
        this.data = data;
    }

    @Override
    public String toString() {
        return "JsonModel [code=" + code + ", msg=" + msg + ", data=" + data + "]";
    }

    public String toJsonString() {
        return JSONObject.toJSONString(this);
    }

}
